﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Text.Editor;
using Microsoft.VisualStudio.Utilities;
using System.ComponentModel.Composition;

namespace Umc.Core.Tools.VSGesture
{
	[Export(typeof(IMouseProcessorProvider))]
	[ContentType("text")]
	[TextViewRole(PredefinedTextViewRoles.Interactive)]
	[Order(Before = PredefinedAdornmentLayers.Selection)]
	[Name("VSGesture Mouse Gesturing")]
	public class VSGestureMouseProcessorProvider : IMouseProcessorProvider
	{
		public VSGestureMouseProcessorProvider()
		{
		}

		[Export(typeof(AdornmentLayerDefinition))]
		[Order(Before = PredefinedAdornmentLayers.Selection)]
		[TextViewRole(PredefinedTextViewRoles.Interactive)]
		[Name("VSGestureWindow")]
		public AdornmentLayerDefinition editorAdornmentLayer;

		public IMouseProcessor GetAssociatedProcessor(IWpfTextView wpfTextView)
		{
			return new Shell.GestureWpfWindow(wpfTextView);
		}
	}
}
